Index: tests/regression/Atoms/Add/testsuite-atoms-add.at
===================================================================
--- tests/regression/Atoms/Add/testsuite-atoms-add.at	(revision 718542b98ffda42460e79001a427f156caa6bcc9)
+++ tests/regression/Atoms/Add/testsuite-atoms-add.at	(revision 7db9bdca097aa9e4f1c2d317be2952824752399f)
@@ -4,9 +4,9 @@
 AT_KEYWORDS([atoms,add-atom])
 AT_CHECK([../../molecuilder -i test.conf -o mpqc pcp xyz tremolo pdb -a 1 --domain-position "10., 10., 10."], 0, [ignore], [ignore])
-AT_CHECK([file=test.conf; diff -I '#.*' $file ${abs_top_srcdir}/${AUTOTEST_PATH}/Atoms/Add/post/test.conf], 0, [ignore], [ignore])
-AT_CHECK([file=test.data; diff -I '#.*' $file ${abs_top_srcdir}/${AUTOTEST_PATH}/Atoms/Add/post/test.data], 0, [ignore], [ignore])
-AT_CHECK([file=test.in; diff -I '.*reated by molecuilder.*' $file ${abs_top_srcdir}/${AUTOTEST_PATH}/Atoms/Add/post/test.in], 0, [ignore], [ignore])
-AT_CHECK([file=test.pdb; diff -I '.*reated by molecuilder.*' $file ${abs_top_srcdir}/${AUTOTEST_PATH}/Atoms/Add/post/test.pdb], 0, [ignore], [ignore])
-AT_CHECK([file=test.xyz; diff -I '.*reated by molecuilder.*' $file ${abs_top_srcdir}/${AUTOTEST_PATH}/Atoms/Add/post/test.xyz], 0, [ignore], [ignore])
+AT_CHECK([file=test.conf; diff -I '#.*' $file ${abs_top_srcdir}/tests/regression/Atoms/Add/post/test.conf], 0, [ignore], [ignore])
+AT_CHECK([file=test.data; diff -I '#.*' $file ${abs_top_srcdir}/tests/regression/Atoms/Add/post/test.data], 0, [ignore], [ignore])
+AT_CHECK([file=test.in; diff -I '.*reated by molecuilder.*' $file ${abs_top_srcdir}/tests/regression/Atoms/Add/post/test.in], 0, [ignore], [ignore])
+AT_CHECK([file=test.pdb; diff -I '.*reated by molecuilder.*' $file ${abs_top_srcdir}/tests/regression/Atoms/Add/post/test.pdb], 0, [ignore], [ignore])
+AT_CHECK([file=test.xyz; diff -I '.*reated by molecuilder.*' $file ${abs_top_srcdir}/tests/regression/Atoms/Add/post/test.xyz], 0, [ignore], [ignore])
 AT_CLEANUP
 
@@ -16,5 +16,5 @@
 
 AT_CHECK([../../molecuilder -i empty.conf -o pcp -a 1 --domain-position "10., 10., 10." --undo], 0, [ignore], [ignore])
-AT_CHECK([file=empty.conf; diff $file ${abs_top_srcdir}/${AUTOTEST_PATH}/Atoms/Add/post/empty.conf], 0, [ignore], [ignore])
+AT_CHECK([file=empty.conf; diff $file ${abs_top_srcdir}/tests/regression/Atoms/Add/post/empty.conf], 0, [ignore], [ignore])
 
 AT_CLEANUP
@@ -25,9 +25,9 @@
 
 AT_CHECK([../../molecuilder -i test.conf -o mpqc pcp xyz tremolo pdb -a 1 --domain-position "10., 10., 10." --undo --redo], 0, [ignore], [ignore])
-AT_CHECK([file=test.conf; diff -I '#.*' $file ${abs_top_srcdir}/${AUTOTEST_PATH}/Atoms/Add/post/test.conf], 0, [ignore], [ignore])
-AT_CHECK([file=test.data; diff -I '#.*' $file ${abs_top_srcdir}/${AUTOTEST_PATH}/Atoms/Add/post/test.data], 0, [ignore], [ignore])
-AT_CHECK([file=test.in; diff -I '#.*' $file ${abs_top_srcdir}/${AUTOTEST_PATH}/Atoms/Add/post/test.in], 0, [ignore], [ignore])
-AT_CHECK([file=test.pdb; diff -I '.*reated by molecuilder.*' $file ${abs_top_srcdir}/${AUTOTEST_PATH}/Atoms/Add/post/test.pdb], 0, [ignore], [ignore])
-AT_CHECK([file=test.xyz; diff -I '.*reated by molecuilder.*' $file ${abs_top_srcdir}/${AUTOTEST_PATH}/Atoms/Add/post/test.xyz], 0, [ignore], [ignore])
+AT_CHECK([file=test.conf; diff -I '#.*' $file ${abs_top_srcdir}/tests/regression/Atoms/Add/post/test.conf], 0, [ignore], [ignore])
+AT_CHECK([file=test.data; diff -I '#.*' $file ${abs_top_srcdir}/tests/regression/Atoms/Add/post/test.data], 0, [ignore], [ignore])
+AT_CHECK([file=test.in; diff -I '#.*' $file ${abs_top_srcdir}/tests/regression/Atoms/Add/post/test.in], 0, [ignore], [ignore])
+AT_CHECK([file=test.pdb; diff -I '.*reated by molecuilder.*' $file ${abs_top_srcdir}/tests/regression/Atoms/Add/post/test.pdb], 0, [ignore], [ignore])
+AT_CHECK([file=test.xyz; diff -I '.*reated by molecuilder.*' $file ${abs_top_srcdir}/tests/regression/Atoms/Add/post/test.xyz], 0, [ignore], [ignore])
 
 AT_CLEANUP
Index: tests/regression/Atoms/ChangeElement/testsuite-atoms-change-element.at
===================================================================
--- tests/regression/Atoms/ChangeElement/testsuite-atoms-change-element.at	(revision 718542b98ffda42460e79001a427f156caa6bcc9)
+++ tests/regression/Atoms/ChangeElement/testsuite-atoms-change-element.at	(revision 7db9bdca097aa9e4f1c2d317be2952824752399f)
@@ -5,8 +5,8 @@
 
 file=test.xyz
-AT_CHECK([/bin/cp -f ${abs_top_srcdir}/${AUTOTEST_PATH}/Atoms/ChangeElement/pre/test.xyz $file], 0)
+AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Atoms/ChangeElement/pre/test.xyz $file], 0)
 AT_CHECK([chmod u+w $file], 0)
 AT_CHECK([../../molecuilder -i $file  --select-atom-by-id 0 -E 6 ], 0, [ignore], [ignore])
-AT_CHECK([diff -I '.*Created by molecuilder.*' $file ${abs_top_srcdir}/${AUTOTEST_PATH}/Atoms/ChangeElement/post/test.xyz], 0, [ignore], [ignore])
+AT_CHECK([diff -I '.*Created by molecuilder.*' $file ${abs_top_srcdir}/tests/regression/Atoms/ChangeElement/post/test.xyz], 0, [ignore], [ignore])
 
 AT_CLEANUP
@@ -17,8 +17,8 @@
 
 file=test.xyz
-AT_CHECK([/bin/cp -f ${abs_top_srcdir}/${AUTOTEST_PATH}/Atoms/ChangeElement/pre/test.xyz $file], 0)
+AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Atoms/ChangeElement/pre/test.xyz $file], 0)
 AT_CHECK([chmod u+w $file], 0)
 AT_CHECK([../../molecuilder -i $file  --select-atom-by-id 0 -E 6 --undo], 0, [ignore], [ignore])
-AT_CHECK([diff -I '.*Created by molecuilder.*' $file ${abs_top_srcdir}/${AUTOTEST_PATH}/Atoms/ChangeElement/post/test-undo.xyz], 0, [ignore], [ignore])
+AT_CHECK([diff -I '.*Created by molecuilder.*' $file ${abs_top_srcdir}/tests/regression/Atoms/ChangeElement/post/test-undo.xyz], 0, [ignore], [ignore])
 
 AT_CLEANUP
@@ -29,8 +29,8 @@
 
 file=test.xyz
-AT_CHECK([/bin/cp -f ${abs_top_srcdir}/${AUTOTEST_PATH}/Atoms/ChangeElement/pre/test.xyz $file], 0)
+AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Atoms/ChangeElement/pre/test.xyz $file], 0)
 AT_CHECK([chmod u+w $file], 0)
 AT_CHECK([../../molecuilder -i $file  --select-atom-by-id 0 -E 6 --undo --redo], 0, [ignore], [ignore])
-AT_CHECK([diff -I '.*Created by molecuilder.*' $file ${abs_top_srcdir}/${AUTOTEST_PATH}/Atoms/ChangeElement/post/test.xyz], 0, [ignore], [ignore])
+AT_CHECK([diff -I '.*Created by molecuilder.*' $file ${abs_top_srcdir}/tests/regression/Atoms/ChangeElement/post/test.xyz], 0, [ignore], [ignore])
 
 AT_CLEANUP
Index: tests/regression/Atoms/Remove/testsuite-atoms-remove.at
===================================================================
--- tests/regression/Atoms/Remove/testsuite-atoms-remove.at	(revision 718542b98ffda42460e79001a427f156caa6bcc9)
+++ tests/regression/Atoms/Remove/testsuite-atoms-remove.at	(revision 7db9bdca097aa9e4f1c2d317be2952824752399f)
@@ -5,10 +5,10 @@
 
 file=test.conf
-AT_CHECK([/bin/cp -f ${abs_top_srcdir}/${AUTOTEST_PATH}/Atoms/Remove/pre/test.conf $file], 0)
+AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Atoms/Remove/pre/test.conf $file], 0)
 AT_CHECK([chmod u+w $file], 0)
 AT_CHECK([../../molecuilder -i $file  -o mpqc pcp xyz --select-atom-by-id 0 -r], 0, [ignore], [ignore])
-AT_CHECK([file=test.conf; diff $file ${abs_top_srcdir}/${AUTOTEST_PATH}/Atoms/Remove/post/test.conf], 0, [ignore], [ignore])
-AT_CHECK([file=test.in; diff $file ${abs_top_srcdir}/${AUTOTEST_PATH}/Atoms/Remove/post/test.in], 0, [ignore], [ignore])
-AT_CHECK([file=test.xyz; diff -I '.*Created by molecuilder.*' $file ${abs_top_srcdir}/${AUTOTEST_PATH}/Atoms/Remove/post/test.xyz], 0, [ignore], [ignore])
+AT_CHECK([file=test.conf; diff $file ${abs_top_srcdir}/tests/regression/Atoms/Remove/post/test.conf], 0, [ignore], [ignore])
+AT_CHECK([file=test.in; diff $file ${abs_top_srcdir}/tests/regression/Atoms/Remove/post/test.in], 0, [ignore], [ignore])
+AT_CHECK([file=test.xyz; diff -I '.*Created by molecuilder.*' $file ${abs_top_srcdir}/tests/regression/Atoms/Remove/post/test.xyz], 0, [ignore], [ignore])
 
 AT_CLEANUP
@@ -19,8 +19,8 @@
 
 file=test.conf
-AT_CHECK([/bin/cp -f ${abs_top_srcdir}/${AUTOTEST_PATH}/Atoms/Remove/pre/test.conf $file], 0)
+AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Atoms/Remove/pre/test.conf $file], 0)
 AT_CHECK([chmod u+w $file], 0)
 AT_CHECK([../../molecuilder -i $file --select-atom-by-id 0 -r --undo], 0, [ignore], [ignore])
-AT_CHECK([diff -I '.*Created by molecuilder.*' $file ${abs_top_srcdir}/${AUTOTEST_PATH}/Atoms/Remove/pre/test.conf], 0, [ignore], [ignore])
+AT_CHECK([diff -I '.*Created by molecuilder.*' $file ${abs_top_srcdir}/tests/regression/Atoms/Remove/pre/test.conf], 0, [ignore], [ignore])
 
 AT_CLEANUP
@@ -31,8 +31,8 @@
 
 file=test.conf
-AT_CHECK([/bin/cp -f ${abs_top_srcdir}/${AUTOTEST_PATH}/Atoms/Remove/pre/test.conf $file], 0)
+AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Atoms/Remove/pre/test.conf $file], 0)
 AT_CHECK([chmod u+w $file], 0)
 AT_CHECK([../../molecuilder -i $file --select-atom-by-id 0 -r --undo --redo], 0, [ignore], [ignore])
-AT_CHECK([diff -I '.*Created by molecuilder.*' $file ${abs_top_srcdir}/${AUTOTEST_PATH}/Atoms/Remove/post/test.conf], 0, [ignore], [ignore])
+AT_CHECK([diff -I '.*Created by molecuilder.*' $file ${abs_top_srcdir}/tests/regression/Atoms/Remove/post/test.conf], 0, [ignore], [ignore])
 
 AT_CLEANUP
Index: tests/regression/Atoms/RemoveCuboid/testsuite-atoms-remove-cuboid.at
===================================================================
--- tests/regression/Atoms/RemoveCuboid/testsuite-atoms-remove-cuboid.at	(revision 718542b98ffda42460e79001a427f156caa6bcc9)
+++ tests/regression/Atoms/RemoveCuboid/testsuite-atoms-remove-cuboid.at	(revision 7db9bdca097aa9e4f1c2d317be2952824752399f)
@@ -5,18 +5,18 @@
 
 file=test-withoutcuboid.xyz
-AT_CHECK([/bin/cp -f ${abs_top_srcdir}/${AUTOTEST_PATH}/Atoms/RemoveCuboid/pre/test.xyz $file], 0)
+AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Atoms/RemoveCuboid/pre/test.xyz $file], 0)
 AT_CHECK([chmod u+w $file], 0)
 AT_CHECK([../../molecuilder -i $file --select-atoms-inside-cuboid "2,2,2" --position "9.78,2.64,2.64" --angle-x 0. --angle-y 0. --angle-z 0. -r], 0, [stdout], [stderr])
 AT_CHECK([sort -n $file | grep -v -E "^[[[:digit:]]]+" | grep -v "Created by" >test-withoutcuboid.xyz-sorted], 0, [ignore], [ignore])
-AT_CHECK([file=test-withoutcuboid.xyz-sorted; diff $file ${abs_top_srcdir}/${AUTOTEST_PATH}/Atoms/RemoveCuboid/post/test-withoutcuboid.xyz-sorted], 0, [ignore], [ignore])
+AT_CHECK([file=test-withoutcuboid.xyz-sorted; diff $file ${abs_top_srcdir}/tests/regression/Atoms/RemoveCuboid/post/test-withoutcuboid.xyz-sorted], 0, [ignore], [ignore])
 
 file=test-cuboid.xyz
-AT_CHECK([/bin/cp -f ${abs_top_srcdir}/${AUTOTEST_PATH}/Atoms/RemoveCuboid/pre/test.xyz $file], 0)
+AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Atoms/RemoveCuboid/pre/test.xyz $file], 0)
 AT_CHECK([chmod u+w $file], 0)
 AT_CHECK([../../molecuilder -i $file --select-all-atoms --unselect-atoms-inside-cuboid "2,2,2" --position "9.78,2.64,2.64" --angle-x 0. --angle-y 0. --angle-z 0. -r], 0, [stdout], [stderr])
 AT_CHECK([sort -n $file | grep -v -E "^[[[:digit:]]]+" | grep -v "Created by" >test-cuboid.xyz-sorted], 0, [ignore], [ignore])
-AT_CHECK([file=test-cuboid.xyz-sorted; diff $file ${abs_top_srcdir}/${AUTOTEST_PATH}/Atoms/RemoveCuboid/post/test-cuboid.xyz-sorted], 0, [ignore], [ignore])
+AT_CHECK([file=test-cuboid.xyz-sorted; diff $file ${abs_top_srcdir}/tests/regression/Atoms/RemoveCuboid/post/test-cuboid.xyz-sorted], 0, [ignore], [ignore])
 AT_CHECK([cat test-cuboid.xyz-sorted test-withoutcuboid.xyz-sorted | sort -n >test.xyz-sorted], 0, [ignore], [ignore])
-AT_CHECK([file=test.xyz-sorted; diff $file ${abs_top_srcdir}/${AUTOTEST_PATH}/Atoms/RemoveCuboid/post/test.xyz-sorted], 0, [ignore], [ignore])
+AT_CHECK([file=test.xyz-sorted; diff $file ${abs_top_srcdir}/tests/regression/Atoms/RemoveCuboid/post/test.xyz-sorted], 0, [ignore], [ignore])
 
 AT_CLEANUP
@@ -27,14 +27,14 @@
 
 file=test.xyz
-AT_CHECK([/bin/cp -f ${abs_top_srcdir}/${AUTOTEST_PATH}/Atoms/RemoveCuboid/pre/test.xyz $file], 0)
+AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Atoms/RemoveCuboid/pre/test.xyz $file], 0)
 AT_CHECK([chmod u+w $file], 0)
 AT_CHECK([../../molecuilder -i $file --select-all-atoms --unselect-atoms-inside-cuboid "2,2,2" --position "9.78,2.64,2.64" --angle-x 0. --angle-y 0. --angle-z 0. -r --undo], 0, [stdout], [stderr])
-AT_CHECK([diff -I '.*Created by molecuilder.*' $file ${abs_top_srcdir}/${AUTOTEST_PATH}/Atoms/RemoveCuboid/pre/$file], 0, [ignore], [ignore])
+AT_CHECK([diff -I '.*Created by molecuilder.*' $file ${abs_top_srcdir}/tests/regression/Atoms/RemoveCuboid/pre/$file], 0, [ignore], [ignore])
 
 file=test.xyz
-AT_CHECK([/bin/cp -f ${abs_top_srcdir}/${AUTOTEST_PATH}/Atoms/RemoveCuboid/pre/test.xyz $file], 0)
+AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Atoms/RemoveCuboid/pre/test.xyz $file], 0)
 AT_CHECK([chmod u+w $file], 0)
 AT_CHECK([../../molecuilder -i $file --select-atoms-inside-cuboid "2,2,2" --position "9.78,2.64,2.64" --angle-x 0. --angle-y 0. --angle-z 0. -r --undo], 0, [stdout], [stderr])
-AT_CHECK([diff -I '.*Created by molecuilder.*' $file ${abs_top_srcdir}/${AUTOTEST_PATH}/Atoms/RemoveCuboid/pre/$file], 0, [ignore], [ignore])
+AT_CHECK([diff -I '.*Created by molecuilder.*' $file ${abs_top_srcdir}/tests/regression/Atoms/RemoveCuboid/pre/$file], 0, [ignore], [ignore])
 
 AT_CLEANUP
@@ -45,18 +45,18 @@
 
 file=test-withoutcuboid.xyz
-AT_CHECK([/bin/cp -f ${abs_top_srcdir}/${AUTOTEST_PATH}/Atoms/RemoveCuboid/pre/test.xyz $file], 0)
+AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Atoms/RemoveCuboid/pre/test.xyz $file], 0)
 AT_CHECK([chmod u+w $file], 0)
 AT_CHECK([../../molecuilder -i $file --select-atoms-inside-cuboid "2,2,2" --position "9.78,2.64,2.64" --angle-x 0. --angle-y 0. --angle-z 0. -r --undo --redo], 0, [stdout], [stderr])
 AT_CHECK([sort -n $file | grep -v -E "^[[[:digit:]]]+" | grep -v "Created by" >test-withoutcuboid.xyz-sorted], 0, [ignore], [ignore])
-AT_CHECK([file=test-withoutcuboid.xyz-sorted; diff $file ${abs_top_srcdir}/${AUTOTEST_PATH}/Atoms/RemoveCuboid/post/test-withoutcuboid.xyz-sorted], 0, [ignore], [ignore])
+AT_CHECK([file=test-withoutcuboid.xyz-sorted; diff $file ${abs_top_srcdir}/tests/regression/Atoms/RemoveCuboid/post/test-withoutcuboid.xyz-sorted], 0, [ignore], [ignore])
 
 file=test-cuboid.xyz
-AT_CHECK([/bin/cp -f ${abs_top_srcdir}/${AUTOTEST_PATH}/Atoms/RemoveCuboid/pre/test.xyz $file], 0)
+AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Atoms/RemoveCuboid/pre/test.xyz $file], 0)
 AT_CHECK([chmod u+w $file], 0)
 AT_CHECK([../../molecuilder -i $file --select-all-atoms --unselect-atoms-inside-cuboid "2,2,2" --position "9.78,2.64,2.64" --angle-x 0. --angle-y 0. --angle-z 0. -r --undo --redo], 0, [stdout], [stderr])
 AT_CHECK([sort -n $file | grep -v -E "^[[[:digit:]]]+" | grep -v "Created by" >test-cuboid.xyz-sorted], 0, [ignore], [ignore])
-AT_CHECK([file=test-cuboid.xyz-sorted; diff $file ${abs_top_srcdir}/${AUTOTEST_PATH}/Atoms/RemoveCuboid/post/test-cuboid.xyz-sorted], 0, [ignore], [ignore])
+AT_CHECK([file=test-cuboid.xyz-sorted; diff $file ${abs_top_srcdir}/tests/regression/Atoms/RemoveCuboid/post/test-cuboid.xyz-sorted], 0, [ignore], [ignore])
 AT_CHECK([cat test-cuboid.xyz-sorted test-withoutcuboid.xyz-sorted | sort -n >test.xyz-sorted], 0, [ignore], [ignore])
-AT_CHECK([file=test.xyz-sorted; diff $file ${abs_top_srcdir}/${AUTOTEST_PATH}/Atoms/RemoveCuboid/post/test.xyz-sorted], 0, [ignore], [ignore])
+AT_CHECK([file=test.xyz-sorted; diff $file ${abs_top_srcdir}/tests/regression/Atoms/RemoveCuboid/post/test.xyz-sorted], 0, [ignore], [ignore])
 
 AT_CLEANUP
Index: tests/regression/Atoms/RemoveSphere/testsuite-atoms-remove-sphere.at
===================================================================
--- tests/regression/Atoms/RemoveSphere/testsuite-atoms-remove-sphere.at	(revision 718542b98ffda42460e79001a427f156caa6bcc9)
+++ tests/regression/Atoms/RemoveSphere/testsuite-atoms-remove-sphere.at	(revision 7db9bdca097aa9e4f1c2d317be2952824752399f)
@@ -5,18 +5,18 @@
 
 file=test-withoutsphere.xyz
-AT_CHECK([/bin/cp -f ${abs_top_srcdir}/${AUTOTEST_PATH}/Atoms/RemoveSphere/pre/test.xyz $file], 0)
+AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Atoms/RemoveSphere/pre/test.xyz $file], 0)
 AT_CHECK([chmod u+w $file], 0)
 AT_CHECK([../../molecuilder -i $file --select-atoms-inside-sphere 7. --position "7.283585982, 3.275186040, 3.535886037" --angle-x 0. --angle-y 0. --angle-z 0. -r], 0, [stdout], [stderr])
 AT_CHECK([sort -n $file | grep -v -E "^[[[:digit:]]]+" | grep -v "Created by" >test-withoutsphere.xyz-sorted], 0, [ignore], [ignore])
-AT_CHECK([file=test-withoutsphere.xyz-sorted; diff $file ${abs_top_srcdir}/${AUTOTEST_PATH}/Atoms/RemoveSphere/post/test-withoutsphere.xyz-sorted], 0, [ignore], [ignore])
+AT_CHECK([file=test-withoutsphere.xyz-sorted; diff $file ${abs_top_srcdir}/tests/regression/Atoms/RemoveSphere/post/test-withoutsphere.xyz-sorted], 0, [ignore], [ignore])
 
 file=test-sphere.xyz
-AT_CHECK([/bin/cp -f ${abs_top_srcdir}/${AUTOTEST_PATH}/Atoms/RemoveSphere/pre/test.xyz $file], 0)
+AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Atoms/RemoveSphere/pre/test.xyz $file], 0)
 AT_CHECK([chmod u+w $file], 0)
 AT_CHECK([../../molecuilder -i $file --select-all-atoms --unselect-atoms-inside-sphere 7. --position "7.283585982, 3.275186040, 3.535886037" --angle-x 0. --angle-y 0. --angle-z 0. -r], 0, [stdout], [stderr])
 AT_CHECK([sort -n $file | grep -v -E "^[[[:digit:]]]+" | grep -v "Created by" >test-sphere.xyz-sorted], 0, [ignore], [ignore])
-AT_CHECK([file=test-sphere.xyz-sorted; diff $file ${abs_top_srcdir}/${AUTOTEST_PATH}/Atoms/RemoveSphere/post/test-sphere.xyz-sorted], 0, [ignore], [ignore])
+AT_CHECK([file=test-sphere.xyz-sorted; diff $file ${abs_top_srcdir}/tests/regression/Atoms/RemoveSphere/post/test-sphere.xyz-sorted], 0, [ignore], [ignore])
 AT_CHECK([cat test-sphere.xyz-sorted test-withoutsphere.xyz-sorted | sort -n >test.xyz-sorted], 0, [ignore], [ignore])
-AT_CHECK([file=test.xyz-sorted; diff $file ${abs_top_srcdir}/${AUTOTEST_PATH}/Atoms/RemoveSphere/post/test.xyz-sorted], 0, [ignore], [ignore])
+AT_CHECK([file=test.xyz-sorted; diff $file ${abs_top_srcdir}/tests/regression/Atoms/RemoveSphere/post/test.xyz-sorted], 0, [ignore], [ignore])
 
 AT_CLEANUP
@@ -27,14 +27,14 @@
 
 file=test.xyz
-AT_CHECK([/bin/cp -f ${abs_top_srcdir}/${AUTOTEST_PATH}/Atoms/RemoveSphere/pre/test.xyz $file], 0)
+AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Atoms/RemoveSphere/pre/test.xyz $file], 0)
 AT_CHECK([chmod u+w $file], 0)
 AT_CHECK([../../molecuilder -i $file --select-atoms-inside-sphere 7. --position "7.283585982, 3.275186040, 3.535886037" --angle-x 0. --angle-y 0. --angle-z 0. -r --undo], 0, [stdout], [stderr])
-AT_CHECK([diff -I '.*Created by molecuilder.*' $file ${abs_top_srcdir}/${AUTOTEST_PATH}/Atoms/RemoveSphere/pre/$file], 0, [ignore], [ignore])
+AT_CHECK([diff -I '.*Created by molecuilder.*' $file ${abs_top_srcdir}/tests/regression/Atoms/RemoveSphere/pre/$file], 0, [ignore], [ignore])
 
 file=test.xyz
-AT_CHECK([/bin/cp -f ${abs_top_srcdir}/${AUTOTEST_PATH}/Atoms/RemoveSphere/pre/test.xyz $file], 0)
+AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Atoms/RemoveSphere/pre/test.xyz $file], 0)
 AT_CHECK([chmod u+w $file], 0)
 AT_CHECK([../../molecuilder -i $file --select-all-atoms --unselect-atoms-inside-sphere 7. --position "7.283585982, 3.275186040, 3.535886037" --angle-x 0. --angle-y 0. --angle-z 0. -r --undo], 0, [stdout], [stderr])
-AT_CHECK([diff -I '.*Created by molecuilder.*' $file ${abs_top_srcdir}/${AUTOTEST_PATH}/Atoms/RemoveSphere/pre/$file], 0, [ignore], [ignore])
+AT_CHECK([diff -I '.*Created by molecuilder.*' $file ${abs_top_srcdir}/tests/regression/Atoms/RemoveSphere/pre/$file], 0, [ignore], [ignore])
 
 AT_CLEANUP
@@ -45,18 +45,18 @@
 
 file=test-withoutsphere.xyz
-AT_CHECK([/bin/cp -f ${abs_top_srcdir}/${AUTOTEST_PATH}/Atoms/RemoveSphere/pre/test.xyz $file], 0)
+AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Atoms/RemoveSphere/pre/test.xyz $file], 0)
 AT_CHECK([chmod u+w $file], 0)
 AT_CHECK([../../molecuilder -i $file --select-atoms-inside-sphere 7. --position "7.283585982, 3.275186040, 3.535886037" --angle-x 0. --angle-y 0. --angle-z 0. -r --undo --redo], 0, [stdout], [stderr])
 AT_CHECK([sort -n $file | grep -v -E "^[[[:digit:]]]+" | grep -v "Created by" >test-withoutsphere.xyz-sorted], 0, [ignore], [ignore])
-AT_CHECK([file=test-withoutsphere.xyz-sorted; diff $file ${abs_top_srcdir}/${AUTOTEST_PATH}/Atoms/RemoveSphere/post/test-withoutsphere.xyz-sorted], 0, [ignore], [ignore])
+AT_CHECK([file=test-withoutsphere.xyz-sorted; diff $file ${abs_top_srcdir}/tests/regression/Atoms/RemoveSphere/post/test-withoutsphere.xyz-sorted], 0, [ignore], [ignore])
 
 file=test-sphere.xyz
-AT_CHECK([/bin/cp -f ${abs_top_srcdir}/${AUTOTEST_PATH}/Atoms/RemoveSphere/pre/test.xyz $file], 0)
+AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Atoms/RemoveSphere/pre/test.xyz $file], 0)
 AT_CHECK([chmod u+w $file], 0)
 AT_CHECK([../../molecuilder -i $file --select-all-atoms --unselect-atoms-inside-sphere 7. --position "7.283585982, 3.275186040, 3.535886037" --angle-x 0. --angle-y 0. --angle-z 0. -r --undo --redo], 0, [stdout], [stderr])
 AT_CHECK([sort -n $file | grep -v -E "^[[[:digit:]]]+" | grep -v "Created by" >test-sphere.xyz-sorted], 0, [ignore], [ignore])
-AT_CHECK([file=test-sphere.xyz-sorted; diff $file ${abs_top_srcdir}/${AUTOTEST_PATH}/Atoms/RemoveSphere/post/test-sphere.xyz-sorted], 0, [ignore], [ignore])
+AT_CHECK([file=test-sphere.xyz-sorted; diff $file ${abs_top_srcdir}/tests/regression/Atoms/RemoveSphere/post/test-sphere.xyz-sorted], 0, [ignore], [ignore])
 AT_CHECK([cat test-sphere.xyz-sorted test-withoutsphere.xyz-sorted | sort -n >test.xyz-sorted], 0, [ignore], [ignore])
-AT_CHECK([file=test.xyz-sorted; diff $file ${abs_top_srcdir}/${AUTOTEST_PATH}/Atoms/RemoveSphere/post/test.xyz-sorted], 0, [ignore], [ignore])
+AT_CHECK([file=test.xyz-sorted; diff $file ${abs_top_srcdir}/tests/regression/Atoms/RemoveSphere/post/test.xyz-sorted], 0, [ignore], [ignore])
 
 AT_CLEANUP
Index: tests/regression/Atoms/SaveSelectedAtoms/testsuite-atoms-save-selected-atoms.at
===================================================================
--- tests/regression/Atoms/SaveSelectedAtoms/testsuite-atoms-save-selected-atoms.at	(revision 718542b98ffda42460e79001a427f156caa6bcc9)
+++ tests/regression/Atoms/SaveSelectedAtoms/testsuite-atoms-save-selected-atoms.at	(revision 7db9bdca097aa9e4f1c2d317be2952824752399f)
@@ -4,7 +4,7 @@
 AT_KEYWORDS([atoms,save,selection,save-selected-atoms])
 
-AT_CHECK([/bin/cp -f ${abs_top_srcdir}/${AUTOTEST_PATH}/Atoms/SaveSelectedAtoms/pre/test.xyz .], 0)
+AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Atoms/SaveSelectedAtoms/pre/test.xyz .], 0)
 AT_CHECK([../../molecuilder -i test.xyz --select-atom-by-id 0 --save-selected-atoms testsave.xyz], 0, [stdout], [stderr])
-AT_CHECK([file=testsave.xyz; diff -I '.*Created by.*' $file ${abs_top_srcdir}/${AUTOTEST_PATH}/Atoms/SaveSelectedAtoms/post/testsave.xyz], 0, [ignore], [ignore])
+AT_CHECK([file=testsave.xyz; diff -I '.*Created by.*' $file ${abs_top_srcdir}/tests/regression/Atoms/SaveSelectedAtoms/post/testsave.xyz], 0, [ignore], [ignore])
 
 AT_CLEANUP
Index: tests/regression/Atoms/Translation/testsuite-atoms-translation.at
===================================================================
--- tests/regression/Atoms/Translation/testsuite-atoms-translation.at	(revision 718542b98ffda42460e79001a427f156caa6bcc9)
+++ tests/regression/Atoms/Translation/testsuite-atoms-translation.at	(revision 7db9bdca097aa9e4f1c2d317be2952824752399f)
@@ -5,8 +5,8 @@
 
 file=test.xyz
-AT_CHECK([/bin/cp -f ${abs_top_srcdir}/${AUTOTEST_PATH}/Atoms/Translation/pre/test.xyz $file], 0)
+AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Atoms/Translation/pre/test.xyz $file], 0)
 AT_CHECK([chmod u+w $file], 0)
 AT_CHECK([../../molecuilder -i $file --select-all-atoms -t "1,0,0"], 0, [stdout], [stderr])
-AT_CHECK([diff -I '.*Created by molecuilder.*' $file ${abs_top_srcdir}/${AUTOTEST_PATH}/Atoms/Translation/post/test-shifted.xyz], 0, [ignore], [ignore])
+AT_CHECK([diff -I '.*Created by molecuilder.*' $file ${abs_top_srcdir}/tests/regression/Atoms/Translation/post/test-shifted.xyz], 0, [ignore], [ignore])
 
 AT_CLEANUP
@@ -17,8 +17,8 @@
 
 file=test.xyz
-AT_CHECK([/bin/cp -f ${abs_top_srcdir}/${AUTOTEST_PATH}/Atoms/Translation/pre/test.xyz $file], 0)
+AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Atoms/Translation/pre/test.xyz $file], 0)
 AT_CHECK([chmod u+w $file], 0)
 AT_CHECK([../../molecuilder -i $file --select-all-atoms -t "1,0,0" --undo], 0, [stdout], [stderr])
-AT_CHECK([diff -I '.*Created by molecuilder.*' $file ${abs_top_srcdir}/${AUTOTEST_PATH}/Atoms/Translation/pre/test.xyz], 0, [ignore], [ignore])
+AT_CHECK([diff -I '.*Created by molecuilder.*' $file ${abs_top_srcdir}/tests/regression/Atoms/Translation/pre/test.xyz], 0, [ignore], [ignore])
 
 AT_CLEANUP
@@ -29,8 +29,8 @@
 
 file=test.xyz
-AT_CHECK([/bin/cp -f ${abs_top_srcdir}/${AUTOTEST_PATH}/Atoms/Translation/pre/test.xyz $file], 0)
+AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Atoms/Translation/pre/test.xyz $file], 0)
 AT_CHECK([chmod u+w $file], 0)
 AT_CHECK([../../molecuilder -i $file --select-all-atoms -t "1,0,0" --undo --redo], 0, [stdout], [stderr])
-AT_CHECK([diff -I '.*Created by molecuilder.*' $file ${abs_top_srcdir}/${AUTOTEST_PATH}/Atoms/Translation/post/test-shifted.xyz], 0, [ignore], [ignore])
+AT_CHECK([diff -I '.*Created by molecuilder.*' $file ${abs_top_srcdir}/tests/regression/Atoms/Translation/post/test-shifted.xyz], 0, [ignore], [ignore])
 
 AT_CLEANUP