Index: tests/Fragmentations/Fragmenting/dimethyl_bromomalonate/testsuite-fragmenting-dimethyl_bromomalonate-order1.at
===================================================================
--- tests/Fragmentations/Fragmenting/dimethyl_bromomalonate/testsuite-fragmenting-dimethyl_bromomalonate-order1.at	(revision c9db50416501589af2b7bec9760cc6129d4b6fe3)
+++ tests/Fragmentations/Fragmenting/dimethyl_bromomalonate/testsuite-fragmenting-dimethyl_bromomalonate-order1.at	(revision 11cc058e1dec8ce8bbb877b9b8b984bfff28f068)
@@ -20,4 +20,5 @@
 AT_SETUP([Fragmentations - dimethyl_bromomalonate order 1])
 AT_KEYWORDS([fragmentation non-convex-envelope])
+AT_XFAIL_IF([/bin/true])
 
 MOL=dimethyl_bromomalonate
Index: tests/Fragmentations/Fragmenting/dimethyl_bromomalonate/testsuite-fragmenting-dimethyl_bromomalonate-order2.at
===================================================================
--- tests/Fragmentations/Fragmenting/dimethyl_bromomalonate/testsuite-fragmenting-dimethyl_bromomalonate-order2.at	(revision c9db50416501589af2b7bec9760cc6129d4b6fe3)
+++ tests/Fragmentations/Fragmenting/dimethyl_bromomalonate/testsuite-fragmenting-dimethyl_bromomalonate-order2.at	(revision 11cc058e1dec8ce8bbb877b9b8b984bfff28f068)
@@ -20,4 +20,5 @@
 AT_SETUP([Fragmentations - dimethyl_bromomalonate order 2])
 AT_KEYWORDS([fragmentation non-convex-envelope])
+AT_XFAIL_IF([/bin/true])
 
 MOL=dimethyl_bromomalonate
Index: tests/Fragmentations/Fragmenting/dimethyl_bromomalonate/testsuite-fragmenting-dimethyl_bromomalonate-order3.at
===================================================================
--- tests/Fragmentations/Fragmenting/dimethyl_bromomalonate/testsuite-fragmenting-dimethyl_bromomalonate-order3.at	(revision c9db50416501589af2b7bec9760cc6129d4b6fe3)
+++ tests/Fragmentations/Fragmenting/dimethyl_bromomalonate/testsuite-fragmenting-dimethyl_bromomalonate-order3.at	(revision 11cc058e1dec8ce8bbb877b9b8b984bfff28f068)
@@ -20,4 +20,5 @@
 AT_SETUP([Fragmentations - dimethyl_bromomalonate order 3])
 AT_KEYWORDS([fragmentation non-convex-envelope])
+AT_XFAIL_IF([/bin/true])
 
 MOL=dimethyl_bromomalonate
Index: tests/Fragmentations/Fragmenting/dimethyl_bromomalonate/testsuite-fragmenting-dimethyl_bromomalonate-order4.at
===================================================================
--- tests/Fragmentations/Fragmenting/dimethyl_bromomalonate/testsuite-fragmenting-dimethyl_bromomalonate-order4.at	(revision c9db50416501589af2b7bec9760cc6129d4b6fe3)
+++ tests/Fragmentations/Fragmenting/dimethyl_bromomalonate/testsuite-fragmenting-dimethyl_bromomalonate-order4.at	(revision 11cc058e1dec8ce8bbb877b9b8b984bfff28f068)
@@ -20,4 +20,5 @@
 AT_SETUP([Fragmentations - dimethyl_bromomalonate order 4])
 AT_KEYWORDS([fragmentation non-convex-envelope])
+AT_XFAIL_IF([/bin/true])
 
 MOL=dimethyl_bromomalonate
Index: tests/Fragmentations/Fragmenting/dimethyl_bromomalonate/testsuite-fragmenting-dimethyl_bromomalonate-order5.at
===================================================================
--- tests/Fragmentations/Fragmenting/dimethyl_bromomalonate/testsuite-fragmenting-dimethyl_bromomalonate-order5.at	(revision c9db50416501589af2b7bec9760cc6129d4b6fe3)
+++ tests/Fragmentations/Fragmenting/dimethyl_bromomalonate/testsuite-fragmenting-dimethyl_bromomalonate-order5.at	(revision 11cc058e1dec8ce8bbb877b9b8b984bfff28f068)
@@ -20,4 +20,5 @@
 AT_SETUP([Fragmentations - dimethyl_bromomalonate order 5])
 AT_KEYWORDS([fragmentation non-convex-envelope])
+AT_XFAIL_IF([/bin/true])
 
 MOL=dimethyl_bromomalonate
Index: tests/Fragmentations/Fragmenting/dimethyl_bromomalonate/testsuite-fragmenting-dimethyl_bromomalonate-order6.at
===================================================================
--- tests/Fragmentations/Fragmenting/dimethyl_bromomalonate/testsuite-fragmenting-dimethyl_bromomalonate-order6.at	(revision c9db50416501589af2b7bec9760cc6129d4b6fe3)
+++ tests/Fragmentations/Fragmenting/dimethyl_bromomalonate/testsuite-fragmenting-dimethyl_bromomalonate-order6.at	(revision 11cc058e1dec8ce8bbb877b9b8b984bfff28f068)
@@ -20,4 +20,5 @@
 AT_SETUP([Fragmentations - dimethyl_bromomalonate order 6])
 AT_KEYWORDS([fragmentation non-convex-envelope])
+AT_XFAIL_IF([/bin/true])
 
 MOL=dimethyl_bromomalonate